import { isObject } from '../util'

const _attr = Symbol('attr')

export class Attr {
  constructor(attrs = {}) {
    this[_attr] = Object.create(null)
    this.set(attrs)
  }

  set(key, value) {
    const obj = this[_attr]

    if (typeof key === 'object') {
      for (const name in key) {
        if (Object.prototype.hasOwnProperty.call(key, name)) {
          obj[name] = merge(obj[name], key[name])
        }
      }

      return obj
    } else {
      if (arguments.length === 1) {
        if (!key) {
          return obj
        }

        return obj[key]
      } else {
        obj[key] = merge(obj[key], value)
        return obj
      }
    }

    function merge(source, newObj) {
      if (!isObject(source) && !isObject(newObj)) {
        return newObj
      } else {
        return Object.assign({}, source, newObj)
      }
    }
  }

  get(key) {
    const obj = this[_attr]

    if (!key) {
      return obj
    }

    return obj[key]
  }
}
