import { isFunction } from '../util'
import { Events } from './Events'
import { Attr } from './Attr'

const states = ['normal', 'hover', 'selected']

export class BaseNode extends Events {
  constructor(attrs = {}) {
    super()
    this.attr = new Attr()
    this.style = new Attr()
    this.attr.set(attrs)
  }

  static get name() {
    return this.constructor.name
  }

  get name() {
    return this.constructor.name
  }

  useStyle(type, style) {
    this.style.set(type, style)
    return this
  }

  getStyle(type) {
    const style = this.style.get(type)

    return (...args) => {
      if (isFunction(style)) {
        return style.apply(this, args)
      } else {
        return style
      }
    }
  }

  useState(type, style) {
    if (states.indexOf(type) < 0) {
      console.warn('useState only support one of [' + states + ']')
      return this
    }

    return this.useStyle(type, style)
  }

  getState(type) {
    return this.getStyle(type)
  }
}
