import { Chart, _addVisual } from './chart'
import Lifecycle from './lifecycle'
import { VisualsMap, ThemeMap } from './registry'

const registerVisual = function(name, Visual) {
  name = name.toLowerCase()
  VisualsMap.set(name, Visual)

  Chart.prototype[name] = function(attrs) {
    return this[_addVisual](name, attrs)
  }
}

const registerTheme = (name, theme) => {
  ThemeMap.set(name, theme)
}

export { Chart, registerVisual, registerTheme, Lifecycle }
